%{

%}

%token IDENT NUMBER
%token BEGIN
%token END
%token TRUE FALSE
%token IF THEN ELSE FI
%token RECORD COLONS
%token CASE VAR_TYPE
%token GOTO 
%token NATIVE OBJECT MACHINE END_OBJECT

%left AND OR
%left EQ NEQ LT GT LE GE 
%left NOT 
%left '+' '-' '*' '/'
 
%start object

%%

object
  : OBJECT IDENT blocks END

blocks
  : block
  | block blocks

block
  : NATIVE
  | record
  machine

record
  : RECORD IDENT '=' '{' ivars '}'

ivars
  : ivar
  | ivar ivars

ivar
  : IDENT VAR_TYPE ';'

machine
  : MACHINE IDENT smDef_list END

smDef_list
  :smDef
  | smDef smDef_list
	
smDef
  :IDENT COLONS condDef_list ';'
	
condDef_list
  : condDef
  | condDef condDef_list
	
condDef
	: IDENT bool_exp action ';'
	
bool_exp
  : TRUE
  | FALSE
  | math_exp math_cmp math_exp
  | bool_exp AND bool_exp
  | bool_exp OR bool_exp
  | NOT bool_exp
  | '(' bool_exp ')'

math_cmp
  : EQ 
  | NEQ 
  | LT 
  | GT 
  | LE 
  | GE


math_exp
  : NUMBER
  | math_exp '+' math_exp
  | math_exp '*' math_exp
  | math_exp '/' math_exp
  | '-' math_exp %prec NOT
  | '(' math_exp ')'

action
  : '{' statement_list '}'

statement_list
  : statement
  | statement statement_list
	
statement
  : if_then
  | func
  | NATIVE
	
if_then
	: IF bool_exp THEN action FI
	| IF bool_exp THEN action ELSE action FI
	
func
	: IDENT '(' arg_list ')'
	
arg_list
	: arg
	| arg arg_list
	
arg
	: IDENT
	
%%

	
